<?php
require "db.php";

if (!is_numeric($_GET['id'])) {
    exit();
}

$id = (int)$_GET['id'];
$_POST['id'] = (int)$_POST['id'];

$row = dbRow("SELECT * FROM languages WHERE record_num = '$id'", false);
if (!is_array($row)) {
    setMessage("Language ID $id does not exist!", 'error');
    pageNotFound(true);
}

if (isset($_POST['formSubmit'])) {

    $_POST = array_map_array('trim', $_POST);

    if ($_POST['name'] == '') {
        setMessage('"Language Name" is required!', 'error');
    }

    if ($_POST['iso'] == '') {
        setMessage('"Language ISO Code" is required!', 'error');
    }

    if (is_array(dbRow("SELECT * FROM `languages` WHERE (`name` = '" . mysqli_real_escape_string($dbconn, $_POST['name']) . "' OR `iso` = '" . mysqli_real_escape_string($dbconn, $_POST['iso']) . "') AND record_num != {$_POST['id']}"))) {
        setMessage('This language name or ISO code already exists!', 'error');
    }

    if (file_exists("$basepath/admin/scripts/validLanguages.json") && !is_writable("$basepath/admin/scripts/validLanguages.json")) {
        setMessage("File <em>$basepath/admin/scripts/validLanguages.json</em> is not writable! Please chmod this file to 0775!", 'error');
    }

    if (!getMessages(false, 'error')) {
        dbUpdate('languages', array(
            'name' => $_POST['name'],
            'iso' => $_POST['iso'],
            'record_num' => $id,
        ));
        $langs = dbQuery("SELECT `iso` FROM `languages`", false);
        foreach ($langs as $_lang) {
            $out[] = $_lang['iso'];
        }
        if (is_array($out)) {
            file_put_contents($basepath . '/admin/scripts/validLanguages.json', json_encode($out));
        }

        $count = 0;
        $meta_collection = dbQuery("SELECT * FROM `metatags` WHERE `language` = '" . mysqli_real_escape_string($dblink, $config['default_language']) . "'", false);
        if (is_array($meta_collection)) {
            foreach ($meta_collection as $_meta_row) {
                unset($_meta_row['record_num']);
                $_meta_row['language'] = $_POST['iso'];
                $insert_id = dbInsert('metatags', $_meta_row, true);
                if (is_numeric($insert_id) && $insert_id > 0) {
                    $count++;
                }
            }
        }

        setMessage('Language saved successfully!');
        
        if ($count > 0) {
            setMessage("$count metatags entries saved! <a href=\"$basehttp/admin/metatags.php?filter%5Blanguage%5D=$_POST[iso]\">View \"$_POST[name]\" metatags</a>");
        }
            
        header("Location: $_SERVER[REQUEST_URI]");
        exit();
    }
}

$_POST += $row;

entities_walk($_POST);
?>

<? require "header.php"; ?>

<div class="content-page">

    <div class="header-area">
        <div class="breadcrumbs">
            <a href="index.php">Admin Home</a>
            <span><a href="languages.php">Manage Languages</a></span>
        </div>
    </div>

    <div class="content-outer">

        <h2>Edit<strong>Language</strong></h2>

        <div class="content-inner">

            <?php echo getMessages(); ?>

            <form method="POST" action="" enctype="multipart/form-data" class="form" novalidate autocomplete="off">
                <table>
                    <thead>
                        <tr>
                            <th colspan="2">Edit Language</th>
                        </tr>
                    </thead>
                    <tr>
                        <td>Name</td>
                        <td><input name="name" type="text" value="<?php echo $_POST['name']; ?>" placeholder="e.g. English" /></td>
                    </tr>
                    <tr>
                        <td>ISO Code <a href="#" title="2-Letter Country Code as per ISO Alpha-2"><i class="ion ion-help-circled"></i></a></td>
                        <td><input name="iso" type="text" value="<?php echo $_POST['iso']; ?>" placeholder="e.g. GB" /></td>
                    </tr>
                    <tr class="item submit">
                        <td colspan="2">
                            <input type="hidden" name="id" value="<?php echo $id; ?>" />
                            <input type="hidden" name="formSubmit" value="1" />
                            <button type="submit" class="btn action-save">Save</button>
                        </td>
                    </tr>
                </table>
            </form>
        </div>
    </div>
</div>

<?php require "footer.php"; ?>
